/* A Screen Editor Subsystem. */
#define TURBOC

#include <stdio.h>
#include <dos.h>
#include <string.h>
#include <bios.h>
#include <conio.h>
#include <process.h>

#define BUF_SIZE 32000
#define LINE_LEN 78
#define MAX_LINES 22
#define KILL_BUF_SIZE 2*LINE_LEN

char buf[BUF_SIZE];
char *curloc , *endloc;
int scrnx , scrny;
char killbuf[KILL_BUF_SIZE];
int counter;
char *helpline =
	 "F1:Save F2:Load F3:Find F4:Replace ^C:Copy line ^K:Cut line ^P:paste ^Z:Quit";

void edit( char *fname ) , help( void );
void gotoxy( int x , int y ) , clrline( int y );
void edit_clr_eol( int x , int y ) , clrscr( void );
void printline( char *p ) , delete_char( void );
void search( char *fname ) , cut( void ) , copy( void );
void upline( void ) ;
void downline( void ) , left( void ) , right( void );
void scrolldn( int x , int y );
void scrollup( int topx , int topy , int endx , int endy );
void display_scrn( int x ,int y , char *p );
void pagedown( char *fname ) , pageup( char *fname ) , replace( char *fname );
void home( char *fname ) , gotoend( char *fname ) , paste( void );
int load( char *fname ) , save( char *fname ) , line_len( void );
void edit_gets( char *str );
void cursor_pos( void );
void line( void );void square ( char *fname );
void _cexit( void );


/***********************************************************************/

void main( int argc , char *argv[] )
{
	char ch;
	if ( argc < 2 )
	{
		printf( "Example of usage: C:\\c31\\work\\>lsedit filename.*(12)" );
		_cexit();
	}
	else
	{       square( argv[1] );
		edit( argv[1] );
		clrscr();

	}
}
/***********************************************************************/

/*main loop*/
void edit( char *fname )
{
	int j;
	union k {
		 char ch[2];
		 unsigned i;
		 }
	key;
	char cha , name[12];


     /*try to load the file*/
	if( !load( fname ) )
		curloc = endloc = buf;
	strcpy( name , fname );

     /*set initial values to x,y*/
	scrnx = scrny = 1;

     /*display a screen full of text*/
	display_scrn( 1 , 1 , curloc );
	clrline( MAX_LINES );
	gotoxy( 12 , MAX_LINES );
	printf( "A new file was created or an existed one is on the screen");
	delay( 2500 );
	help();

	counter = 0;/*ᜠ 㨜  killed line*/

	/*editor main loop*/
	do
	{
		#ifdef TURBOC
			key.i = bioskey( 0 );
		#endif
		#ifdef MICROSOFTC
			key.i = _bios_keybrd( 0 );
		#endif


		if ( !key.ch[0] ) /*is a command*/
		{
			switch ( key.ch[1] )
			{
				case 59 : /*F1:Save file*/
					save( name );
					clrline( MAX_LINES );
					gotoxy( 33 , MAX_LINES );
					printf( "File is saved" );
					delay(1500);
					help();
					gotoxy( scrnx , scrny ); /*position cursor*/
					break;
				case 60 : /*F2:Load file*/
					clrline( MAX_LINES );
					gotoxy( 1 , MAX_LINES );
					printf( "Enter file name:" );
					edit_gets( name );
					if ( *name )
						load( name );
					clrscr();
					square( name );
					help();
					display_scrn( 1 , 1 , curloc );
					scrnx = scrny = 1;
					gotoxy( scrnx , scrny ); /*position cursor*/
					break;
				case 61 : /*F3:Search*/
					search( name );
					gotoxy( scrnx , scrny ); /*position cursor*/
					break;
				case 62 : /*F4:Replace*/
					replace( name );
					gotoxy( scrnx , scrny ); /*position cursor*/
					break;
				case 71 : /*Home*/
					home( name );
					gotoxy( scrnx , scrny ); /*position cursor*/
					break;
				case 79 : /*End*/
					gotoend( name );
					break;
				case 75 : /*Left*/
					left();
					gotoxy( scrnx , scrny ); /*position cursor*/
					break;
				case 77 : /*Right*/
					right();
					gotoxy( scrnx , scrny ); /*position cursor*/
					break;
				case 72 : /*Up*/
					upline();
					gotoxy( scrnx , scrny ); /*position cursor*/
					break;
				case 80 : /*Down*/
					downline();
					gotoxy( scrnx , scrny ); /*position cursor*/
					break;
				case 73 : /*Page up*/
					pageup( name );
					gotoxy( scrnx , scrny ); /*position cursor*/
					break;
				case 81 : /*Page down*/
					pagedown( name );
					gotoxy( scrnx , scrny ); /*position cursor*/
					break;
				case 83 : /*Del*/
					if ( curloc < endloc )
					delete_char();
					gotoxy( scrnx , scrny ); /*position cursor*/
					break;
			}
			if ( curloc < buf )
			{
				scrny = scrnx = 1;
				curloc = buf;
			}
		}
		else
		{
			switch ( key.ch[0] )
			{
				case '\r' : /*Carriage return*/
				  /*see if buffer is full*/
					  if ( endloc == buf+BUF_SIZE-2 )
						break;
				  /*move contents of file bellow
				    current location down one
				    byte to make room for the return*/
					  memmove( curloc+1 , curloc , endloc-curloc+1 );

				  /*put return in file*/
					  *curloc = key.ch[0];
					  curloc++;

					  /*clear rest of line*/
					  edit_clr_eol( scrnx , scrny );
					  scrnx = 1;
					  scrny++;


					  /*move text on screen down*/
					  if ( scrny == MAX_LINES )  /*at bottom of page*/
					  {
						scrny = MAX_LINES-1;
						scrollup( 1 , 1 , LINE_LEN , scrny);
					  }
					  else
						scrolldn( scrnx , scrny );

					  gotoxy ( scrnx , scrny );
					  printline( curloc ); /*display the line*/
					  endloc++; /*advance the end of file pointer*/
					  break;
				case '\b' : /*Backspace*/
					  if ( curloc == buf )
						break;
					  left();
					  delete_char();
					  break;
				case '\t' :/*Tab*/
					  if ( line_len() > ( LINE_LEN-9 ) )
					  {
						clrline( MAX_LINES );
						gotoxy( 24 , MAX_LINES );
						printf( "Can't insert tab character" );
						delay( 1500 );
						help();
					  }
					  else
						for ( j = 1; j < 10; j++ )
							if ( ( endloc+1 ) == ( buf+BUF_SIZE-2 ) )
							{
								clrline( MAX_LINES );
								gotoxy( 28 , MAX_LINES );
								printf( "No more space" );
								delay( 1500 );
								help();
							}
							else
							{
								memmove( curloc+1 , curloc , endloc-curloc+1 );
								printf( " " );
								*curloc = ' ';
								printline( curloc );
								curloc++;
								endloc++;
								scrnx++;
								gotoxy( scrnx-1 , scrny );

							}
					  break;

				case  3   : /*Contrl-c:Copy line*/
					  copy();
					  break;
				case 11   : /*Contrl-k:Cut line*/
					  cut();
					  break;
				case 16   : /*Control-p:Yank kill buffer*/
					  paste();
					  break;
				default   : /*see if buffer is full*/
					  if ( endloc == buf+BUF_SIZE-2 )
						break;
					    /*can't type past end of line*/
					  if ( scrnx == LINE_LEN )
						break;
					  if ( line_len() > LINE_LEN && key.ch[0] != 26 )
					  {
						clrline( MAX_LINES );
						gotoxy( 12 , MAX_LINES );
						printf( "Can't insert any more characters at this line" );
						delay( 1500 );
						help();
					  }
					  else
					  {
					    /*move contents of file below current location down one byte
					      to make room fo rthe character*/
					  memmove( curloc+1 , curloc , endloc-curloc+1 );
					  *curloc = key.ch[0]; /*put key stroke in file*/
					  putch( *curloc );/*display key on the screen*/
					  scrnx++; /*advance X*/
					  gotoxy( scrnx , scrny );
					  printline( curloc+1 );/*display the line*/
					  curloc++;/*advance the current location*/
					  endloc++;/*advance the end of file pointer*/
					  }
			}
			gotoxy( scrnx , scrny );
		}/*T⢦  if*/
	}while( key.ch[0] != 26 );/*^Z quits the editor*/
	   /*T⢦  do-while*/

	/* saving before ending*/
	if ( key.ch[0] == 26 )
	{
		clrline( MAX_LINES );
		gotoxy( 26 , MAX_LINES );
		printf( "Save before exit? (Y/N)" );
		cha = getch();
		if ( cha == 'Y' || cha == 'y' || cha == '' || cha == 'Y' )
			save( name );

	}

}
/***********************************************************************/

/*Display a line pointed to by p.This function stops when it hits
carriage return or the end of the file*/
void printline( register char *p )
{
	register int i;

	i = scrnx;
	while ( *p != '\r' && *p && i < LINE_LEN )
	{
		putch( *p );
		p++;
		i++;
	}
}
/***********************************************************************/
/*Copy line*/
void copy( void )
{
	cut();
	gotoxy( scrnx , scrny );
	paste();

}
/***********************************************************************/
/*Insert previously killed line*/
void paste( void )
{
	register int i;
	char *p ;

	i = scrnx;
	if ( ( counter > ( LINE_LEN-line_len() ) ) || ( (counter + i ) > LINE_LEN ) )
	{
		clrline( MAX_LINES );
		gotoxy( 23 , MAX_LINES );
		printf( "You can't paste here" );
		delay( 1500 );
		help();
	}
	else
	{
		p = killbuf;
		while( *p )
		{
			memmove( curloc+1 , curloc , endloc-curloc+1 );
			*curloc = *p;/*put keystroke infile*/
			putch( *curloc );/*display the key on the screen*/
			scrnx++;
			curloc++;
			endloc++;
			p++;
		}
		printline( curloc );
	}
}
/***********************************************************************/

/*Delete the line at the current location*/
void cut( void )
{
	register int i;
	char *p , *killbufptr;

	if  ( *curloc == '\r' )
	{
		delete_char();
		return;
	}

	edit_clr_eol( scrnx , scrny ); /*Clear to CR*/

	/*Find out how many characters are in the line*/
	p = curloc;
	i = 0;
	killbufptr = killbuf;
	while( *p != '\r' && p < endloc )
	{
		i++;
		*killbufptr = *p;/*Put in kill buffer*/
		p++;
		if ( killbufptr < killbuf+KILL_BUF_SIZE-2 )
			killbufptr++;
	}
	counter = i;
	*killbufptr = '\0';
	/*Remove the line*/
	memmove( curloc , curloc+i , endloc-curloc );
	endloc -= i;
}/*⢦  cut()
/**********************************************************************/

/*Global search and replace*/
void replace( char *fname )
{
	register int len1;
	char str1[78] , str2[78];
	char *p , *p2 , name[12];;

	strcpy( name , fname );
	clrline( MAX_LINES );
	gotoxy( 1 , MAX_LINES );
	printf( "Enter string to replace:" );
	edit_gets( str1 );
	if ( !*str1 )
	{
		help();
		return;
	}

	clrline( MAX_LINES );
	gotoxy( 1 , MAX_LINES );
	printf( "Enter replacement:" );
	edit_gets( str2 );

	p = curloc;
	len1 = strlen( str1 );
	while ( *str1 )
	{  /*Search for the string*/
		while ( *p && strncmp( str1 , p , len1 ) )
			p++;
		if ( !*p )  /*Not found*/
			break;
		/*Remove old string */
		memmove( p , p+len1 , endloc-p );
		endloc -= len1;

		/*Insert new string*/
		p2 = str2;
		while ( *p2 )
		{
			memmove ( p+1 , p , endloc-p+1 );
			*p = *p2;
			p++;
			endloc++;
			p2++;
		}
	}
	clrscr();

	/*Find location of top of screen*/
	p = curloc;
	for ( len1 = scrny; len1 >= 0 && p > buf; )
	{
		p--;
		if ( *p == '\r' )
			len1--;
	}
	if ( *p == '\r' )
		p++;
	/*Redisplay current screen*/
	square( name );
	display_scrn( 1 , 1 , p );
	help();
}
/**********************************************************************/
/* Delete character at the current location.  */
void delete_char( void )
{
	char *p;
	int len1 , len2;

	gotoxy( scrnx , scrny );

	if ( *curloc == '\r' )
	{     /* Return , scroll display */
		p = curloc;
		len1 = line_len();
		curloc = curloc+1;
		len2 = line_len();
		curloc = p;
		if ( ( len1+len2 ) > LINE_LEN  )
		{
			clrline( MAX_LINES );
			gotoxy( 25 , MAX_LINES );
			printf( "You can't insert next line here." );
			delay( 1500 );
			help();
			return;
		}
		else
		{
			scrollup( 1 , scrny+1 , LINE_LEN , MAX_LINES-1 );
			memmove( curloc , curloc+1 , endloc-curloc );
			endloc--;
			display_scrn( scrnx , scrny , curloc );
			help();
		}
	}
	else

	{
		memmove( curloc , curloc+1 , endloc-curloc );
		endloc--;
		printline( curloc );
		printf(" ");
	}
}
/**********************************************************************/

/*Display help line*/
void help( void )
{
	gotoxy( 1 , MAX_LINES );
	printf( helpline );
	gotoxy( scrnx , scrny );
}
/**********************************************************************/

/*Move current location left*/
void left( void )
{
	if ( curloc == buf )
		return; /*can't go left*/
	scrnx--;
	if ( scrnx < 1 )
	{ /*at the begining of line*/
		scrnx = 1;
		upline();/*go up to next line*/
		/*find end of line*/
		while ( *curloc != '\r' )
		{
			curloc++;
			scrnx++;
		}
	}
	else
		curloc--;
}
/**********************************************************************/

/*Move current position right*/
void right( void )
{
	/*Can't move right*/
	if ( curloc+1 > endloc )
		return;

	scrnx++;

	/*If at the end of the file go to the next one*/
	if ( scrnx > LINE_LEN || *curloc == '\r' )
	{
		scrnx = 1;
		scrny++;
		if ( scrny == MAX_LINES )/*at the end of the screen*/
		{
			scrny = MAX_LINES-1;
			downline(); /*get next line*/
			/*move cursor and current loc to start of new line*/
			curloc--;
			while ( *curloc != '\r' )
				curloc--;
			curloc++;
			scrnx = 1;
		}
		else
			curloc++;
	}
	else
		curloc++;
}
/**********************************************************************/
/*Find a string*/
void search( char *fname )
{
	char str[78];
	char name[12];
	register char *p;
	int len,i;

	strcpy( name , fname );
	clrline( MAX_LINES );/*clear message line*/
	gotoxy( 1 , MAX_LINES );
	printf( "search string:" );
	edit_gets( str );
	if ( !*str )
		return;

	p = curloc;
	len = strlen( str );

	/*search for the string*/
	while ( *p && strncmp( str , p , len ) )
		p++;

	if ( !*p )
	{
		clrline( MAX_LINES );/*clear message line*/
		gotoxy( 31 , MAX_LINES );
		printf( "String not found" );
		delay( 1500 );
		help();
		return;/*not found*/
	}
	/*back up to the start of line*/
	i = 1;
	while ( p >= buf && *p != '\r' )
	{
		p--;
		i++;
	}
	p++;
	i--;

	/*reposition current location to start of match*/
	curloc = p+i-1;
	scrnx = i;
	scrny = 1;
	/*display screen of text at location of match*/
	clrscr();
	square( name );
	display_scrn( 1 , 1 , p );
	help();
}
/************************************************************************/
/*move up one line.If possible keep scrnx same as in previos line*/
void upline( void )
{
	register int i;
	char *p;
	if ( curloc == buf )
		return;/*at first byte in buffer*/

	p = curloc;

	if ( *p == '\r' )
		p--;/*if at end of line back up*/

	/*back up locator to start of current line*/
	for ( ; *p != '\r' && p > buf; p-- );
		if ( *p != '\r' )
			return;/*at first line can not go up*/
	curloc = p;
	curloc--;/*skip past CR*/
	i = scrnx; /*save X coordinate*/

	/*First start of next line*/
	while ( *curloc != '\r' && curloc >= buf )
		curloc--;
	scrny--;
	scrnx = 1;
	curloc++;

	/*at top of screen must scroll up*/
	if ( scrny < 1 )
	{
		scrolldn( 1 , 1 );
		scrny = 1;
		gotoxy( 1 , 1 );
		printline( curloc );
	}
	/*position the cursor and current location at
	  same scrnx position as previous line as possible*/
	  while ( i > 1 && *curloc != '\r' )
	  {
		curloc++;
		scrnx++;
		i--;
	  }
}
/**********************************************************************/

/*Move down one line.Keep previous scrnx location if possible*/
void downline( void )
{
	register int i;
	char *p;

	i = scrnx;
	p = curloc;

	/*advance current location to start of next line*/
	while( *p != '\r' && p < endloc )
		p++;   /*proxorao sti grammi*/
	if ( p == endloc )
		return;/*can't go down*/
	p++; /*skip past CR*/
	curloc = p;
	scrny++;
	scrnx = 1;

	/*if moving down past the bottom of the screen*/
	if ( scrny == MAX_LINES )
	{
		scrny = MAX_LINES-1;
		scrollup( 1 , 1 , LINE_LEN , MAX_LINES-1 );
		gotoxy( scrnx , scrny );
		printline( curloc );
	}
	/*advance to corresponding character in next line*/
	while ( i > 1 && *curloc != '\r' && curloc < endloc )
	{
		curloc++;
		scrnx++;
		i--;         /*     
				   */
	 }
}
/**********************************************************************/

/*Display a screen full of text (up to 24 lines) starting at the
  specified location*/
void display_scrn( int x , int y , char *p )
{
	register int i;
	gotoxy( x , y );

	i = 0;
	while ( y < MAX_LINES && *p )
	{
		switch( *p )      /* y =  */
		{
			case '\r' :
				  printf( "\n" );
				  y++;
				  i = 1;
				  gotoxy( 1 , y );
				  break;
			default   :
				  if ( i < LINE_LEN )
					putch( *p );
				  i++;
		}
		p++;
	}
}
/**********************************************************************/
/*Page down*/
void pagedown( char *fname )
{
	register int i;
	char name[12];

	clrscr();

	/*Count down MAX LINES lines */
	for ( i = 1; i < MAX_LINES && curloc < endloc; )
	{
		if ( *curloc == '\r' )
			i++;
		curloc++;
	}
	scrnx = 1;
	scrny = 1;
	strcpy( name , fname );
	square( fname );
	display_scrn( 1 , 1 , curloc );
	help();
}
/**********************************************************************/
/*Page up MAX_LINES lines*/
void pageup( char *fname )
{
	register int i;
	char name[12];

	clrscr();
	/*if current location points to a CR, move
	  current location back on position*/
	if ( *curloc == '\r' && curloc > buf )
		curloc--;

	/*go back MAX_LINES in buffer*/
	for ( i = 1; i < MAX_LINES+1 && curloc > buf; )
	{
		if ( *curloc == '\r' )
			i++;
		curloc--;
	}

	scrnx = 1;
	scrny = 1;
	strcpy( name , fname );
	square( name );
	display_scrn( 1 , 1 , curloc );
	help();
}
/**********************************************************************/

/*Go to the top of the file*/
void home( char *fname )
{
	char name[12];

	clrscr();
	curloc = buf;
	scrnx = scrny = 1;
	strcpy( name , fname );
	square( name );
	display_scrn( 1 , 1 , curloc );
	help();
}
/**********************************************************************/

/*Go to the end of the file*/
void gotoend( char *fname )
{
	int i;
	char name[12];

	clrscr();
	strcpy( name, fname );
	curloc = endloc;
	pageup( name );
	for ( i=1; i < MAX_LINES+1; i++ )
		downline();
	gotoxy( scrnx , scrny );
}
/**********************************************************************/

/*Load a file*/
load( char *fname )
{
	int x , y;
	FILE *fp;
	char ch , *p , cha;
	char name[12];

	if ( ( fp = fopen( fname , "rb" ) ) == NULL )
	{
		clrline( MAX_LINES );
		gotoxy( 32 , MAX_LINES );
		printf( "File not found" );
		delay( 1500 );
		return 0;
	}
	strcpy( name , fname );
	square( name );
	p = buf;
	while ( !feof( fp ) && p != buf+BUF_SIZE-2 )
	{
		ch = getc( fp );
		if ( ch != '\n' && ch != EOF )
		{

			*p = ch;
			p++;
		}
	}
	*p = '\0';
	fclose( fp );
	curloc = buf;
	endloc = p;
	return 1;
}
/**********************************************************************/

/*Save a file */
save( char *fname )
{
	FILE *fp;
	char *p , name[12];

	if ( ! *fname )
	{
		printf( "filename:" );
		gets( name );
	}
	else strcpy( name , fname );

	if ( ( fp =fopen( name ,"wb" ) ) == NULL )
		return 0;

	p = buf;
	while ( p != endloc )
	{
		if ( *p != '\r' && *p != '\x1A' )
			putc( *p , fp );
		else
		{
			if ( *p == '\r' )
			{
				putc( '\r' , fp );
				putc( '\n' , fp );
			}
			else
				if ( *p == '\x1A' );
		}
		p++;
	}
	endloc = p;
	fclose( fp );
	return 1;
}
/**********************************************************************/

/*Read a string from the keyboard, but do not scroll
  the display when a RETURN is entered*/
void edit_gets( char *str )
{
	char *p;
	p = str;

	for( ; ; )
	{
		*str = getch();
		if ( *str == '\r' ) /*when RETURN entered*/
		{
			*str = '\0'; /*NULL terminate*/
			return;
		}
		if ( *str == '\b' ) /*backspace*/
		{
			if ( str > p )
			{
				str--;
				putch( '\b' );
				putch( ' ' );
				putch( '\b' );
			}
		}
		else
		{
			putch( *str );
			str++;
		}
	}
}
/**********************************************************************/

/*Read and save cursor coordinates*/
void cursor_pos( void )
{
	union REGS i , o;

	i.h.bh = 0;
	i.h.ah = 3;
	int86( 16 , &i , &o );
}
/**********************************************************************/

/*Send cursor to specified X<Y (0,0 is upper left corner)*/
void gotoxy( int x ,int y )
{
	union REGS i;

	i.h.dh = y;
	i.h.dl = x;
	i.h.ah = 2;
	i.h.bh = 0;
	int86( 16 , &i , &i );
}
/**********************************************************************/

/*Clean entire line given its Y coordinate*/
void clrline( int y )
{
	register int i;

	gotoxy( 1 , y );
	for ( i = 1; i < LINE_LEN; i++ )
		putch( ' ' );
}
/**********************************************************************/

/*Clear to end of specified line.This  */
void edit_clr_eol( int x , int y )
{
	char *p;

	p = curloc;
	gotoxy( x , y );
	for( ; x < LINE_LEN && *p != '\r' && *p; x++ , p++ )
		printf( " " );
}
/**********************************************************************/

/*Clear the screen*/
void clrscr( void )
{
	union REGS r;

	r.h.ah = 6;
	r.h.al = 0;
	r.h.ch = 0;
	r.h.cl = 0;
	r.h.dh = MAX_LINES;
	r.h.dl = LINE_LEN;
	r.h.bh = 7;
	int86( 0x10 , &r , &r );
}
/**********************************************************************/

/*Scroll down the screen*/
void scrolldn( int x , int y )
{
	union REGS r;

	r.h.ah = 7;
	r.h.al = 1;
	r.h.ch = y;
	r.h.cl = x;
	r.h.dh = MAX_LINES-1;
	r.h.dl = LINE_LEN;
	r.h.bh = 7;
	int86( 0x10 , &r , &r );
}
/**********************************************************************/

/*Scroll up*/
void scrollup( int topx , int topy , int endx , int endy )
{
	union REGS r;

	r.h.ah = 6;
	r.h.al = 1;
	r.h.ch = topy;
	r.h.cl = topx;
	r.h.dh = endy;
	r.h.dl = endx;
	r.h.bh = 7;
	int86( 0x10 , &r , &r );
}

/**********************************************************************/
void square( char *fname )
{
	#define CATHETOS printf( "\xBA" )
	#define LEFT_UP printf( "\xC9" )
	#define RIGHT_UP printf( "\xBB" )
	#define LEFT_DOWN printf( "\xC8" )
	#define RIGHT_DOWN printf( "\xBC" )

	int i;
	char name[12];

	strcpy( name , fname );
	clrscr();
	gotoxy( 0 , 0 );
	LEFT_UP;
	line();
	gotoxy( 34 , 0 );
	puts( name );
	gotoxy( 79 , 0 );
	RIGHT_UP;
	for ( i = 1; i < 23; i++ )
	{
		CATHETOS;
		gotoxy( 79 , i );
		CATHETOS;
	}
	LEFT_DOWN;
	line();
	RIGHT_DOWN;

}

/**********************************************************************/
 void line ( void )
{
	int i;

	for ( i = 0; i < MAX_LINES-3 ; i++ )
		printf( "\xCD\xCD\xCD\xCD" );
	printf( "\xCD\xCD" );
}
/**********************************************************************/
/*Find out how many characters are in the line*/
int line_len ( void )
{
	char *p , *pos;
	int i , j;
	if ( *curloc == '\r' )
		p = curloc-1;
	else
		p = pos = curloc;
/*back up to the start of line*/
	j = 1;
	while ( p >= buf && *p != '\r' )
	{
		p--;
		j++;
	}
	p++;
	j--;

	i = 1;
	while( *pos != '\r' && pos < endloc )
	{
		i++;
		pos++;
	}
	return i+j;
}
/**********************************************************************/
